	var STATEMENTS = {
		'true'    : true,
		'false'   : false,
		'break'   : null,
		'const'   : null,
		'continue': null,
		'if'      : null,
		'else'	  : null,
		'label'   : null,
		'return'  : null,
		'switch'  : null,
		'throw'   : null,
		'try'     : null,
		'var'     : null,
		'with'    : null,
		'while'   : null,
		'for'     : null,
		'function': null
	};
	
	var SPECIAL_OPERATORS = {
		'delete'	: null,
		'in'		: null,
		'instanceof': null,
		'new'		: null,
		'this'		: null,
		'typeof'	: null,
		'void'		: null
	};
	
	var GLOBALS = [
		'Array',
		'String',
		'Object',
		'Boolean',
		'Date',
		'Error',
		'EvalError',
		'Function',
		'Math',
		'Number',
		'RangeError',
		'ReferenceError',
		'RegExp',
		'SyntaxError',
		'TypeError',
		'URIError',
		'decodeURI',
		'decodeURIComponent',
		'encodeURI',
		'encodeURIComponent',
		'escape',
		'unescape',
		'eval',
		'isFinite',
		'isNaN',
		'parseFloat',
		'parseInt',
		'Infinity',
		'NaN',
		'undefined',
		'JSON',
		'arguments'
	];  
	
	var KeyGenerator = function(ar){
		if(!DebuggerService.isOn){
			try{
				DebuggerService.on();
			}
			catch(ex){}
		}	
		var r = [];
		if(ExtensionManagerUtils.isFirefox4OrLater){
			for(var i=0,l=ar.length;i<l;++i){
				var obj = ar[i];
				var _obj = obj;
				var ret = {};
				var statements = obj == STATEMENTS;
				var operators  = obj == SPECIAL_OPERATORS;
				try{
					for(; obj; obj = obj.__proto__){
						for(let [, p] in Iterator(Object.getOwnPropertyNames(obj))){
							try{
								var oValue = _obj[p];
								var type  = (statements && oValue === null) && '[object Statement]' || (operators) && '[object Operator]' || (oValue === null) &&  '[object null]' || Object.prototype.toString.call(oValue);
								var type2 = (statements && oValue === null) && 'statement' || (operators) && 'operator' || (oValue === null) &&  'null' || typeof oValue;
							}
							catch(ex){
								continue
							}
							if(r.indexOf(p) >= 0)
								continue;
							r.push(p);
							yield {
								v    : p,
								type : type,
								type2: type2
							};
						};
					};
				}
				catch(ex){
				}
			};			
		}
		else{
			for(var i=0,l=ar.length;i<l;++i){
				var obj = ar[i];
				var _obj = obj;
				var top = DebuggerService.wrapValue(obj);
				var ret = {};
				var statements = obj == STATEMENTS;
				var operators  = obj == SPECIAL_OPERATORS;
				try{
					for(; obj; obj = obj.__proto__){
						DebuggerService.wrapValue(obj).getProperties(ret, {});
						for(var j=0,l=ret.value.length;j<l;++j){
							var p    = ret.value[j];
							var name = p.name;
							var v    = name.stringValue;//name.getWrappedValue();
							var type = top.getProperty(v).value.getWrappedValue();
							var type2;
							try{
								var oValue = _obj[v];
								type  = (statements && oValue === null) && '[object Statement]' || (operators) && '[object Operator]' || (oValue === null) &&  '[object null]' || Object.prototype.toString.call(oValue);
								type2 = (statements && oValue === null) && 'statement' || (operators) && 'operator' || (oValue === null) &&  'null' || typeof oValue;
							}
							catch(ex){
								continue;
							}
							if(r.indexOf(v) >= 0)
								continue;
							r.push(v);
							yield {
								v    : v,
								type : type,
								type2: type2
							};
						};
					};
				}
				catch(ex){
				}
			};
		}
	};
	
	var CommandLine = null; 
	var AcebugEditor = null;
	
	var Autocompleter = {
		keyup: function(evt){
			var target = evt.target;
			var originalTarget = evt.originalTarget;
			var value = originalTarget.value;
			if((target.id === 'fbCommandLine' || target.id === 'fbLargeCommandLine' || target.id === 'fbCommandEditor' || (originalTarget.baseURI === 'chrome://acebug/content/fbace/fbeditor.html' && originalTarget.localName === 'textarea' && ExtensionManagerUtils.isFirefox4OrLater)) && this.enable){
				if(this.exKey || !this.largeCommandLine && !this.enableOneline){
					this.hidePopup();
					return;
				}
				this.keyEvt = evt;
				if(originalTarget.baseURI === 'chrome://acebug/content/fbace/fbeditor.html'){
					var acePos   = Firebug.Ace.win2.editor.getCursorPosition();
					this.text    = Firebug.Ace.win2.editor.session.getLine(acePos.row).substring(0,acePos.column);
					AcebugEditor = Firebug.Ace.win2.editor;
					_Acebug.replaceFunction();
				}
				else{
					this.text    = originalTarget.value.substr(0,originalTarget.selectionEnd);
					CommandLine  = originalTarget;
					AcebugEditor = null;
				}
				switch(evt.keyCode){
					case evt.DOM_VK_BACK_SPACE:
						this.hidePopup();
					break;
					
					case evt.DOM_VK_SHIFT:
						var popup = this.popup;
						if(popup.state === 'open' || popup.state === 'showing'){
							return;
						}
					break;
					
					case evt.DOM_VK_UP:
					case evt.DOM_VK_PAGE_UP:
					case evt.DOM_VK_DOWN:
					case evt.DOM_VK_PAGE_DOWN:
						this.preventKeyEvent(evt);
					return;
					
					case evt.DOM_VK_LEFT:  
					case evt.DOM_VK_RIGHT:
						this.hidePopup();
					return;
					
					case evt.DOM_VK_ENTER:
					case evt.DOM_VK_RETURN:
						this.hidePopup();
					return;
					
					case evt.DOM_VK_TAB:
						if(!this.largeCommandLine){
							this.hidePopup();
						}	
					return;
					
					case evt.DOM_VK_CANCEL: 
					case evt.DOM_VK_HELP: 
					case evt.DOM_VK_CLEAR: 
					case evt.DOM_VK_CONTROL:
					case evt.DOM_VK_ALT:
					case evt.DOM_VK_PAUSE:
					case evt.DOM_VK_CAPS_LOCK: 
					case evt.DOM_VK_ESCAPE: 
					case evt.DOM_VK_SPACE: 
					case evt.DOM_VK_END: 
					case evt.DOM_VK_HOME: 
					case evt.DOM_VK_PRINTSCREEN:
					case evt.DOM_VK_INSERT:
					case evt.DOM_VK_DELETE:
					case evt.DOM_VK_SEMICOLON: 
					case evt.DOM_VK_EQUALS:
					case evt.DOM_VK_CONTEXT_MENU:
					case evt.DOM_VK_MULTIPLY:
					case evt.DOM_VK_ADD:
					case evt.DOM_VK_SEPARATOR:
					case evt.DOM_VK_SUBTRACT:
					case evt.DOM_VK_DECIMAL:
					case evt.DOM_VK_DIVIDE:
					case evt.DOM_VK_NUM_LOCK:
					case evt.DOM_VK_SCROLL_LOCK:
					case evt.DOM_VK_COMMA:
					//case evt.DOM_VK_PERIOD:
					case evt.DOM_VK_SLASH: 
					case evt.DOM_VK_BACK_QUOTE:
					case evt.DOM_VK_OPEN_BRACKET: 
					case evt.DOM_VK_BACK_SLASH:
					case evt.DOM_VK_CLOSE_BRACKET:
					case evt.DOM_VK_QUOTE:
					case evt.DOM_VK_META:
					case evt.DOM_VK_NUMPAD0:
					case evt.DOM_VK_NUMPAD1:
					case evt.DOM_VK_NUMPAD2:
					case evt.DOM_VK_NUMPAD3:
					case evt.DOM_VK_NUMPAD4:
					case evt.DOM_VK_NUMPAD5:
					case evt.DOM_VK_NUMPAD6:
					case evt.DOM_VK_NUMPAD7: 
					case evt.DOM_VK_NUMPAD8:
					case evt.DOM_VK_NUMPAD9:
					case evt.DOM_VK_F1:
					case evt.DOM_VK_F2:
					case evt.DOM_VK_F3:
					case evt.DOM_VK_F4:
					case evt.DOM_VK_F5:
					case evt.DOM_VK_F6:
					case evt.DOM_VK_F7:
					case evt.DOM_VK_F8: 
					case evt.DOM_VK_F9:  
					case evt.DOM_VK_F10: 
					case evt.DOM_VK_F11: 
					case evt.DOM_VK_F12: 
					case evt.DOM_VK_F13:
					case evt.DOM_VK_F14:
					case evt.DOM_VK_F15:
					case evt.DOM_VK_F16: 
					case evt.DOM_VK_F17: 
					case evt.DOM_VK_F18:
					case evt.DOM_VK_F19:
					case evt.DOM_VK_F20: 
					case evt.DOM_VK_F21:
					case evt.DOM_VK_F22: 
					case evt.DOM_VK_F23:
					case evt.DOM_VK_F24:
						this.hidePopup();
					return;
				}
				this.onPopup();
				originalTarget.focus();
			}	
		},
		keypress: function(evt){
			var target = evt.target
			var originalTarget = evt.originalTarget;
			var value = originalTarget.value;
			if((target.id === 'fbCommandLine' || target.id === 'fbLargeCommandLine' || target.id === 'fbCommandEditor' || (originalTarget.baseURI === 'chrome://acebug/content/fbace/fbeditor.html' && originalTarget.localName === 'textarea' && ExtensionManagerUtils.isFirefox4OrLater)) && this.enable){
				if(evt.shiftKey && evt.keyCode === evt.DOM_VK_TAB && this.largeCommandLine){
					this.changePopupEle(evt,false);	
				}	
				this.exKey = evt.altKey || evt.ctrlKey || evt.shiftKey && 
							!!~[
								evt.DOM_VK_LEFT,
								evt.DOM_VK_RIGHT,
								evt.DOM_VK_UP,
								evt.DOM_VK_PAGE_UP,
								evt.DOM_VK_DOWN,
								evt.DOM_VK_PAGE_DOWN
							].indexOf(evt.keyCode);
					
				if(evt.shiftKey || evt.altKey || evt.ctrlKey)
					return;
				
				switch(evt.keyCode){
					case evt.DOM_VK_UP:
					case evt.DOM_VK_PAGE_UP:
						this.changePopupEle(evt,false);
					return;
					
					case evt.DOM_VK_DOWN:
					case evt.DOM_VK_PAGE_DOWN:
						this.changePopupEle(evt,true);
					return;
					
					case evt.DOM_VK_TAB:
						if(this.largeCommandLine){
							this.changePopupEle(evt,true);
						}
					return;
					
					case evt.DOM_VK_LEFT: 
					case evt.DOM_VK_RIGHT: 
						this.hidePopup();
					return;
					
					case evt.DOM_VK_ENTER:
					case evt.DOM_VK_RETURN:
						this.selectPopupEle(evt);
					return;
				}
			}	
		},
		onPopup: function(){
			var popup = this.popup;
			if(popup.state === 'open' || popup.state === 'showing'){
				this.filterEle();
			}
			this.openPopup();
		},
		preventKeyEvent: function(evt){
			var popup = this.popup;
			if(popup.state === 'open' || popup.state === 'showing'){
				evt.preventDefault();
				evt.stopPropagation();
			}
		},
		get keys(){
			var fBugContext  = (typeof FirebugContext === 'object') && FirebugContext || 
							   (typeof Firebug === 'object')        && Firebug.currentContext || 
							   (typeof opener === 'object')         && opener.Firebug.currentContext;
			var unsafeWindow = fBugContext.getGlobalScope().wrappedJSObject;		   
			var value = this.text;
			var reg = /\s+|\n+|;|\(|\)|\{|\}/g;
			if(reg.test(value)){
				var matchValues = value.match(reg);
					matchValues = value.split(matchValues[matchValues.length - 1]);
				value = matchValues[matchValues.length - 1];
			}	
			var c = 0;
			var obj = unsafeWindow;
			var keys = [];
			var values = value.split('.');

			var gObjIndex = GLOBALS.indexOf(values[0]);
			if(values.length === 2 && gObjIndex >= 0){
				obj = window;
			}
			
			ObserverService.notifyObservers(null,'FirebugAutocompleter-oninput-commandline',values.slice(values.length - 2).join('.'));
			
			values.pop();
			values.forEach(function(str){
				if(str){
					try{
						var ars = str.split('[');
						if(ars.length > 1){
							ars.forEach(function(str){
								str = str.replace(/\]|"|'/g,'');
								obj = obj[str];
							});
						}
						else
							obj = obj[str];
					}
					catch(ex){
						obj = null;
					}
					++c;
				}
				else{
					obj = null;
				}
			});	
			
			if(!c){
				keys.push(STATEMENTS);
				keys.push(SPECIAL_OPERATORS);
				var _gObj = {};
				GLOBALS.forEach(function(w){
					_gObj[w] = window[w];
				});
				keys.push(_gObj);
			}
			
			if(obj == unsafeWindow.window){
				obj = unsafeWindow;
			}	
			else
			if(obj === undefined){
				values = values[values.length - 1].replace(/'/g,'"');
				try{
					obj = JSON.parse(values);
				}
				catch(ex){
					obj = '';
				}
			}
			
			var isXMLPrototype = false;
			try{
				isXMLPrototype = (obj == unsafeWindow.XML.prototype);
			}
			catch(ex){
			}
			if(isXMLPrototype){
				obj = '';
			}
			
			var type;
			try{
				type = (obj) && Object.prototype.toString.call(obj) || null;
			}
			catch(ex){
			}
			if(type === '[object String]' || type === '[object Array]'){
				obj = window[type.match(/\w+/g)[1]];
			}
			keys.push(obj);
			var keyObj = KeyGenerator(keys);
			return [i for(i in keyObj)];
		},
		createEle: function(evt){
			var popup = this.popup;
			var vbox  = popup.querySelector('vbox');
			var keyEvt = this.keyEvt;
			var value = this.text;
			var reg = /\s+|\n+|;|,|\(|\)|\{|\}/g;
			if(reg.test(value)){
				var matchValues = value.match(reg);
					matchValues = value.split(matchValues[matchValues.length - 1]);
				value = matchValues[matchValues.length - 1];
			}
			var values = value.split('.');
			var lastValue = values[values.length - 1];
			try{
				reg = new RegExp('^'+lastValue,'i');
			}
			catch(ex){
				evt.preventDefault();
				evt.stopPropagation();
				return;
			}
			var keys = this.keys.filter(function(obj){
				if(reg.test(obj.v))
					return obj;
			});
			if(!values[0] || !value.length || !keys.length ||
			   (keyEvt.keyCode === keyEvt.DOM_VK_BACK_SPACE && values.length === 1 && !lastValue.length)){
				evt.preventDefault();
				evt.stopPropagation();
				return;
			}	
			var self = this;
			var iconic   = PrefUtils.getPref('extensions.firebugautocompleter.iconic.enable');
			var sortType = PrefUtils.getPref('extensions.firebugautocompleter.sort');
			keys.sort(function(a,b){
				return a.v - b.v;
			});
			switch(sortType){
				default:
				case 0:
					keys.sort(function(a,b){
						if(!parseInt(a.v))
							return a.v.toLowerCase() > b.v.toLowerCase();
					});
				break;
				
				case 1:
					keys.sort(function(a,b){
						return a.type2 > b.type2;
					});
				break;
			}
			keys.forEach(function(obj,i){
				var v     = obj.v;
				var type  = obj.type;
					type  = type.split(/\s+/)[1].replace(']','');
				var type2 = obj.type2; 	
				if(type2 === 'undefined'){	
					type = type2; 
				}
				var mItem = document.createElementNS(XUL,'menuitem');
				mItem.setAttribute('label',v);
				if(iconic){
					mItem.setAttribute('class','FirebugAutocompleter_popup_menuitem menuitem-iconic');
					mItem.setAttribute('_type',type);
				}				
				else{
					mItem.setAttribute('class','FirebugAutocompleter_popup_menuitem');
				}
				mItem.setAttribute('tooltiptext',type);
				mItem.setAttribute('hidden','false');
				if(lastValue === v){
					Array.forEach(vbox.querySelectorAll('menuitem.FirebugAutocompleter_popup_menuitem[hidden="false"][_moz-menuactive="true"]'),function(node){
						node.removeAttribute('_moz-menuactive');
					});
					mItem.setAttribute('current','true');
					mItem.setAttribute('_moz-menuactive','true');
					vbox.insertBefore(mItem,vbox.firstChild);
				}	
				else{
					if(i === 0)
						mItem.setAttribute('_moz-menuactive','true');
					vbox.appendChild(mItem);
				}
			});
		},
		filterEle: function(){
			var popup     = this.popup;
			var vbox      = popup.querySelector('vbox');
			var menuitems = vbox.querySelectorAll('menuitem.FirebugAutocompleter_popup_menuitem'); 
			var textarea = CommandLine;
			var value = this.text;
			var reg = /\s+|\n+|;|,|\(|\)|\{|\}/g;
			if(reg.test(value)){
				var matchValues = value.match(reg);
					matchValues = value.split(matchValues[matchValues.length - 1]);
				value = matchValues[matchValues.length - 1];
			}
			var values = value.split('.');
			var lastValue = values[values.length - 1];
			try{
				reg = new RegExp('^'+lastValue,'i');
			}
			catch(ex){
				this.hidePopup();
				return;
			}
			var keys = [];
			this.keys.forEach(function(obj){
				if(reg.test(obj.v)){
					keys.push(obj.v);
				}
			});
			if(!value.length || !keys.length || !lastValue.length){
				this.hidePopup();
				return;
			}	
			Array.forEach(menuitems,function(menuitem){
				var label  = menuitem.label;
				var hidden = 'false';
				if(keys.indexOf(label) < 0){
					hidden = 'true';
				}
				if(lastValue === label){
					menuitem.setAttribute('current','true');
					var clone = menuitem.cloneNode(true);
					var parent = menuitem.parentNode;
					parent.removeChild(menuitem);
					parent.insertBefore(clone,parent.firstChild);
					Array.forEach(vbox.querySelectorAll('menuitem.FirebugAutocompleter_popup_menuitem[hidden="false"][_moz-menuactive="true"]'),function(node){
						node.removeAttribute('_moz-menuactive');
					});
				}
				else{
					menuitem.removeAttribute('current');
				}
				menuitem.setAttribute('hidden',hidden);
			});
			var menuitemActive = vbox.querySelector('menuitem.FirebugAutocompleter_popup_menuitem[hidden="false"][_moz-menuactive="true"]');
			var menuitemFirst  = vbox.querySelector('menuitem.FirebugAutocompleter_popup_menuitem[hidden="false"]');
			if(!menuitemActive && menuitemFirst){
				menuitemFirst.setAttribute('_moz-menuactive','true');
			}
			if(vbox.querySelectorAll('menuitem[hidden="false"]').length < 1){
				this.hidePopup();
			}
		},
		menuitemCommand: function(originalTarget){
			var label = originalTarget && originalTarget.label || '';
			if(/^\d+|\$|\/|:|\.|#/.test(label)){
				if(/'/.test(label)){
					label = '[\'' + label + '\']';
				}
				else{
					label = '["' + label + '"]';
				}
			}
			if(AcebugEditor){
				var texts = this.text.split(/\s+|\.|\(/);
				var lastText = texts[texts.length - 1];
				Array.forEach(lastText,function(str){
					AcebugEditor.removeLeft();
				});
				if(/^\[.*\]$/.test(label)){
					AcebugEditor.removeLeft();
				}
				AcebugEditor.insert(label);
				ObserverService.notifyObservers(null,'FirebugAutocompleter-oninput-commandline',label);
				return;
			}
			var commandLine = CommandLine;
			if(!commandLine)
				return;
			var sTop  = commandLine.scrollTop;
			var value = commandLine.value;
			var value1 = value.slice(0,commandLine.selectionEnd);
			var value2 = value.slice(commandLine.selectionEnd);
			var firstValues = value1.split('.');
			var reg = /\s+|\n+|;|,|\(|\)|\{|\}/g;
			var fve = firstValues[firstValues.length - 1];
			if(reg.test(fve)){
				var matchValues = fve.match(reg);
				var mve = matchValues[matchValues.length - 1];
				matchValues = fve.split(mve);
				matchValues[matchValues.length - 1] = label;
				firstValues[firstValues.length - 1] = matchValues.join(mve);
			}
			else{
				firstValues[firstValues.length - 1] = label;	
			}
			value1 = firstValues.join('.');
			if(/^\[|]$/.test(label)){
				firstValues.pop();
				value1 = firstValues.join('.') + label;
			}
			commandLine.value = value1 + value2;	
			commandLine.scrollTop = sTop;
			commandLine.selectionEnd = value1.length;
			
			firstValues = firstValues.slice(firstValues.length - 2).join('.');
			if(reg.test(firstValues)){
				var matchFirstValues = firstValues.match(reg);
				firstValues = firstValues.split(matchFirstValues[matchFirstValues.length - 1]);
				firstValues = firstValues[firstValues.length - 1];
			}
			ObserverService.notifyObservers(null,'FirebugAutocompleter-oninput-commandline',firstValues);
		},
		destroy: function(){
			var popup = this.popup;
			var vbox  = popup.querySelector('vbox');
			while(vbox.firstChild){
				vbox.removeChild(vbox.firstChild);
			};
		},
		selectPopupEle: function(evt){
			var self  = this;
			var popup = this.popup;
			if(popup.state === 'open' || popup.state === 'showing'){
				var mEvt = document.createEvent('MouseEvents');
				mEvt.initMouseEvent(
					'command',
					true,
					true,
					window,
					0,
					0,
					0,
					0,
					0,
					false,
					false,
					false,
					false,
					0,
					null
				);
				var menuitem = document.querySelector('menuitem.FirebugAutocompleter_popup_menuitem[_moz-menuactive="true"]');
				if(menuitem){
					menuitem.dispatchEvent(mEvt);
					setTimeout(function(){
						self.hidePopup();
					},100);
					evt.preventDefault();
					evt.stopPropagation();
				}	
				else{
					this.hidePopup();
				}
			}
		},
		changePopupEle: function(evt,down){
			var self  = this;
			var popup = this.popup;
			if(popup.state === 'open' || popup.state === 'showing'){
				var st = 0;
				var tooltipLabel = document.querySelector('#FirebugAutocompleter_tooltip_type label');
				var aMenuitem = document.querySelector('menuitem.FirebugAutocompleter_popup_menuitem[hidden="false"][_moz-menuactive="true"]');
				var aMIndex   = aMenuitem && (down && aMenuitem.nextSibling || !down && aMenuitem.previousSibling) || null;
				if(down){
					while(aMIndex && aMIndex.hidden === true){
						aMIndex = aMIndex.nextSibling;
					};
				}
				else{
					while(aMIndex && aMIndex.hidden === true){
						aMIndex = aMIndex.previousSibling;
					};
				}
				var stMax = 5;
				if(aMenuitem){
					stMax = parseInt(aMenuitem.parentNode.boxObject.height / 2 / aMenuitem.boxObject.height); 
				}
				var menuitems = document.querySelectorAll('menuitem.FirebugAutocompleter_popup_menuitem[hidden="false"]');
				Array.forEach(menuitems,function(menuitem,i){
					if(i === 0 && !aMIndex && down || i === (menuitems.length - 1) && !aMIndex && !down || menuitem == aMIndex){
						menuitem.setAttribute('_moz-menuactive','true');
						st = menuitem.clientHeight * (i - stMax);
					}	
					else{
						menuitem.removeAttribute('_moz-menuactive');
					}	
				});
				var vbox = popup.querySelector('vbox');
				vbox.scrollTop = st;
				evt.preventDefault();
				evt.stopPropagation();
				return true;
			}
			else{
				return false;
			}
		},
		openPopup: function(){
			var popup = this.popup;
			if(popup.state === 'closed'){
				if(AcebugEditor){
					var renderer = AcebugEditor.renderer;
					var cursor   = renderer.$cursorLayer.cursor;
					var scroller = renderer.scroller;	
					setTimeout(function(){
						var x = PrefUtils.getPref('extensions.firebugautocompleter.popup.position.x');
						var y = PrefUtils.getPref('extensions.firebugautocompleter.popup.position.y') + cursor.offsetHeight;
						popup.openPopup((cursor || scroller),'overlap',x,y,false,false);
					},20);
					return;
				}
				var textarea = CommandLine;
				var editor = textarea.editor || textarea.QueryInterface(Ci.nsIDOMNSEditableElement).editor;
				var sController = editor.selectionController;
				var selection = editor.selection;
				var anchorNode = selection.anchorNode;
				var focusNode  = selection.focusNode;
				var x = PrefUtils.getPref('extensions.firebugautocompleter.popup.position.x');
				var y = PrefUtils.getPref('extensions.firebugautocompleter.popup.position.y');
				if(ExtensionManagerUtils.isFirefox4OrLater){
					var target = (focusNode.nodeValue) ? focusNode: focusNode.firstChild;
					var range = document.createRange();
					range.setStart(target,textarea.selectionStart);
					range.setEnd(target,textarea.selectionStart);
					var rangeRect = range.getBoundingClientRect(); 
					range.detach();
					x += rangeRect.left;
					y += rangeRect.top;
					if(textarea.localName === 'input'){
						var fbCommandBox = textarea.ownerDocument.getElementById('fbCommandBox');
						y -= fbCommandBox.boxObject.height;
					}
					else{
						y += rangeRect.height;
					}
					//chrome://firebug/content/firefox/firebugFrame.xul firebug 1.9
					if(target.baseURI !== 'chrome://browser/content/browser.xul' && document.baseURI === 'chrome://browser/content/browser.xul'){
						var firebug = target.ownerDocument.documentElement;
						y += firebug.boxObject.screenY - window.screenY;
					}
					popup.openPopup(null,'overlap',x,y,false,false);
				}
				else{
					var div = focusNode.parentNode;
					var br  = focusNode.nextSibling || div.appendChild(focusNode.ownerDocument.createElementNS(XHTML,'br'));
					if(br.nodeName === '#text'){
						br = DOMUtils.xpath('following-sibling::xhtml:br[1]',br)[0];
					}
					var prevTxts = textarea.value.substring(0,textarea.selectionEnd).split(/\n+/);
						prevTxts = prevTxts[prevTxts.length - 1] || '';
					var currentTxts = textarea.value.substring(textarea.selectionStart).split(/\n+/)[0];
					var brPreEle = br.previousElementSibling || textarea;
					var brPreTxt = br.previousSibling;
					if(currentTxts){
						var textRect = this.getTxtOffset(br,prevTxts);
						x += textarea.getBoundingClientRect().left - br.getBoundingClientRect().left + textRect.left - textarea.getBoundingClientRect().left; 
						y += brPreEle.getBoundingClientRect().top - br.getBoundingClientRect().top + ((brPreEle.getBoundingClientRect().top - br.getBoundingClientRect().top < 0) ? textRect.top: 0);
					}
					popup.openPopup(br,'after_start',x,y,false,false);
				}
			}
		},
		hidePopup: function(){
			var popup = this.popup;
			if(popup.state === 'open' || popup.state === 'showing'){
				popup.hidePopup();
			}
		},
		getTxtOffset: function(br,str){
			var span = br.ownerDocument.createElementNS(XHTML,'span');
			span.className = 'FirebugAutocompleter_moz_dirty_span';
			span.textContent = str;
			span.style.setProperty('margin','0','important');
			span.style.setProperty('padding','0','important');
			span.style.setProperty('border','none','important');
			br.parentNode.appendChild(span);
			var sBr = br.ownerDocument.createElementNS(XHTML,'br');
			br.parentNode.appendChild(sBr);
			var offset = {
				left: sBr.getBoundingClientRect().left,
				top : span.offsetHeight
			};
			span.parentNode.removeChild(span);
			br.parentNode.removeChild(sBr);
			return offset;
		},
		get enable(){
			return PrefUtils.getPref('extensions.firebugautocompleter.enable');
		},
		get enableOneline(){
			return PrefUtils.getPref('extensions.firebugautocompleter.oneline.enable');
		},
		get largeCommandLine(){
			return (_Firebug.commandEditor) ? PrefUtils.getPref('extensions.firebug.commandEditor'): PrefUtils.getPref('extensions.firebug.largeCommandLine');
		},
		get popup(){
			delete this.popup;
			return this.popup = document.getElementById('FirebugAutocompleter_popup');
		}
	};
