	var handleEvent = function(evt){
		var target = evt.target;
		var originalTarget = evt.originalTarget;
		switch(evt.type){
			case 'load':
				window.removeEventListener(evt.type,this,false);
				window.addEventListener('unload',this,false);
				document.addEventListener('keyup',this,true);
				document.addEventListener('keydown',this,false);
				document.addEventListener('keypress',this,true);
				document.addEventListener('popupshowing',this,false);
				document.addEventListener('popuphiding',this,false);
				document.addEventListener('command',this,false);
				Statusbar.update();
				Observer.register();
				Style.register();
				
				_Firebug.updateCommandLineListener();
				try{
					Firebug.chrome.$('fbCommandLineCompletionList').addEventListener('popupshowing',this,false);
				}
				catch(ex){}
			break;
			
			case 'unload':
				window.removeEventListener(evt.type,this,false);
				document.removeEventListener('keyup',this,true);
				document.removeEventListener('keydown',this,false);
				document.removeEventListener('keypress',this,true);
				document.removeEventListener('popupshowing',this,false);
				document.removeEventListener('popuphiding',this,false);
				document.removeEventListener('command',this,false);
				Observer.unregister();
				try{
					Firebug.chrome.$('fbCommandLineCompletionList').removeEventListener('popupshowing',this,false);
				}
				catch(ex){}
			break;
			
			case 'keyup':
				Autocompleter.keyup(evt);
			break;
			
			case 'keydown':
				if(target.id === 'fbCommandLine' && Autocompleter.enable && Autocompleter.enableOneline){
					_Firebug.onCommandLineKeyDown(evt);
				}
			break;
			
			case 'keypress':
				Autocompleter.keypress(evt);
			break;
			
			case 'popupshowing':
				switch(originalTarget.id){
					case 'FirebugAutocompleter_popup':
						Autocompleter.createEle(evt);
					return;
					
					case 'fbCommandLineCompletionList':
						if(Autocompleter.enable && PrefUtils.getPref('extensions.firebugautocompleter.oneline.enable')){
							evt.preventDefault();
							evt.stopPropagation();	
						}
					return;
					
					case 'FirebugAutocompleter_menupopup':
						Popup.updateMainMenupopup(originalTarget);
					return;
				}
			break;
			
			case 'popuphiding':
				switch(originalTarget.id){
					case 'FirebugAutocompleter_popup':
						Autocompleter.destroy();
					return;
				}	
			break;
			
			case 'command':
				switch(originalTarget.id){
					case 'cmd-open-FirebugAutocompleter-options':
						OpenOptionWindow();
					return;
					
					case 'FirebugAutocompleter_statusbarpanel':
					case 'FirebugAutocompleter_menupopup_toggle_enable':
						PrefUtils.toggle('extensions.firebugautocompleter.enable');
					return;
				}
				if(/^FirebugAutocompleter_popup_menuitem/.test(originalTarget.className)){
					Autocompleter.menuitemCommand(originalTarget);
					return;
				}	
			break;
		}
	};