	var Sidebar = {
		onLoad: function(){
			var browser = WindowMediator.getMostRecentWindow('navigator:browser');
			var value   = browser.FirebugAutocompleter.Autocompleter.text || '';
			var reg = /\s+|\n+|;|\(|\)|\{|\}/g;
			if(reg.test(value)){
				var vm = value.match(reg);
				var vs = value.split(vm[vm.length - 1]);
				value = vs[vs.length - 1];
			}	
			var m = this.onQueryMatch(value);
			if(!m){
				value = PrefUtils.getPref('extensions.firebugautocompleter.reference.lastkeyname');
				this.onQueryMatch(value);
			}
		},
		onQueryMatch: function(str){
			var xml  = this.referenceXML;
			var strSplit = str.split('.');
			var strSplitLast = strSplit[strSplit.length - 1];
			var xmlNode;
			try{
				xmlNode = str.length && xml.querySelector(strSplit[0] + ' method[name="'+strSplitLast+'"],' + strSplit[0] + ' property[name="'+strSplitLast+'"]') || 
						  str.length && xml.querySelector('method[name="'+strSplitLast+'"],' + 'property[name="'+strSplitLast+'"]');
			}
			catch(ex){
				xmlNode = str.length && xml.querySelector('method[name="'+strSplitLast+'"],' + 'property[name="'+strSplitLast+'"]');
			}
			if(!xmlNode)
				return false;
			PrefUtils.setPref('extensions.firebugautocompleter.reference.lastkeyname',str);	
			var bundle = this.bundle;	
			var locale = this.locale;
			var summary = xmlNode.querySelector('summary >'+locale);
			var link = 'https://developer.mozilla.org/'+(summary && locale || 'en')+'/'+xmlNode.querySelector('link').textContent;
			var keyNameNode = document.getElementById('key_name');
				keyNameNode.textContent = xmlNode.getAttribute('name');
				keyNameNode.setAttribute('href',link);
				keyNameNode.setAttribute('tooltiptext',link);
			var summaryNode = document.getElementById('summary');
				summaryNode.textContent = (summary || xmlNode.querySelector('summary > en')).textContent;
			var syntaxNode = document.getElementById('syntax');
				syntaxNode.textContent = xmlNode.querySelector('syntax').textContent;
			var paramsBox = document.getElementById('parameters_box');
			while(paramsBox.firstChild){
				paramsBox.removeChild(paramsBox.firstChild);
			};
			var params = xmlNode.querySelectorAll('params > param');
			if(!params.length){
				var paramNone = document.createElementNS(XUL,'description');
				paramNone.setAttribute('class','none');
				paramNone.textContent = bundle.getString('NONE');
				paramsBox.appendChild(paramNone);
			}
			Array.forEach(params,function(param){
				var name = document.createElementNS(XUL,'description');
					name.textContent = param.getAttribute('name');
				var des  = document.createElementNS(XUL,'description');
					des.textContent = (param.querySelector(locale) || param.querySelector('en')).textContent;
				paramsBox.appendChild(name);
				paramsBox.appendChild(des);
			});
			var des = xmlNode.querySelector('desc > '+locale) || xmlNode.querySelector('desc > en');
			var desNode = document.getElementById('description');
				desNode.textContent = des && des.textContent || bundle.getString('NONE');
			var exampleBox = document.getElementById('example_code_box');				
			while(exampleBox.firstChild){
				exampleBox.removeChild(exampleBox.firstChild);
			};
			var example = xmlNode.querySelector('examples > example');	
			if(example){
				var exampleDes  = example.querySelector('desc > '+locale) || example.querySelector('desc > en');
					exampleDes  = exampleDes && exampleDes.textContent || '';
				var exampleCode = example.querySelector('code > '+locale) || example.querySelector('code > en') || example.querySelector('code > all');
					exampleCode = exampleCode && exampleCode.textContent || '';
				var exampleLabel = document.createElementNS(XUL,'label');
					exampleLabel.setAttribute('value','Code');
					exampleBox.appendChild(exampleLabel);	
				var exampleArea = document.createElementNS(XUL,'textbox');	
					exampleArea.setAttribute('class','example_code');
					exampleArea.setAttribute('multiline','true');
					exampleArea.setAttribute('readonly','true');
					exampleArea.setAttribute('value',(exampleDes && [exampleDes.replace(/^(\n+)|\t+/g,''),exampleCode.replace(/^(\n+)|\t+/g,'')].join('\n') || exampleCode.replace(/^(\n+)|\t+/g,'')));
					exampleBox.appendChild(exampleArea);
			}
			document.querySelector('#FirebugAutocompleter_panel > vbox').scrollTop = 0;
			return true;
		},
		getXMLContents: function(fName){
			var dom = '';
			var file = this.installLocationFile;
			if(/\.xpi$/.test(file.leafName)){
				var reader = Cc['@mozilla.org/libjar/zip-reader;1'].createInstance(Ci.nsIZipReader);
				try{
					reader.open(file);
					file = reader.getInputStream('chrome/content/'+ fName);
					reader.close();
				}
				catch(ex){}
			}
			else{
				file.append('chrome');
				file.append('content');
				file.append(fName);
			}
			var data = FileIOUtils.read(file);
			var domParser = new DOMParser();
			dom = domParser.parseFromString(data,'text/xml');
			dom = (dom.documentElement.nodeName !== 'parsererror') && dom.documentElement || '';
			return dom;
		},
		get bundle(){
			delete this.bundle;
			return this.bundle = document.getElementById('bundle_main');
		},
		get locale(){
			delete this.locale;
			return this.locale = this.bundle.getString('LANG');
		},
		get installLocationFile(){
			delete this.installLocationFile;
			return this.installLocationFile = ExtensionManagerUtils.getInstallLocation(ADDON_ID) || ExtensionManagerUtils.getInstallLocation(ADDON_ID + '.xpi');
		},
		get referenceXML(){
			delete this.referenceXML;
			var dom = this.getXMLContents('reference.xml');
			return this.referenceXML = dom;
		}
	};