	var Style = {
		register: function(){
			var style  = this.code;
			this.style = style;
			var uri = makeURI(style,null,null);
			if(!StyleSheetService.sheetRegistered(uri, StyleSheetService.USER_SHEET))
				StyleSheetService.loadAndRegisterSheet(uri, StyleSheetService.USER_SHEET);	
		},
		unregister: function(){
			if(!this.style)
				return;
			var uri = makeURI(this.style,null,null);
			if(StyleSheetService.sheetRegistered(uri, StyleSheetService.USER_SHEET))
				StyleSheetService.unregisterSheet(uri, StyleSheetService.USER_SHEET);
		},
		updateCode: function(){
			this.unregister();
			
			var style = this.code;
			
			this.style = style;
			
			/* update style */
			var uri = makeURI(style,null,null);
			if(!StyleSheetService.sheetRegistered(uri, StyleSheetService.USER_SHEET))
				StyleSheetService.loadAndRegisterSheet(uri, StyleSheetService.USER_SHEET);
		},
		get code(){
			var code = <>
				@namespace url({XUL});
			</>.toString();
			var r = [
				'Statement',
				'Operator',
				'Function',
				'Array',
				'Number',
				'Object',
				'Boolean',
				'String',
				'RegExp',
				'undefined',
				'null'
			];
			r.forEach(function(str){
				var low  = str.toLowerCase();
				var pref = PrefUtils.getPref('extensions.firebugautocompleter.color.' + low);
				if(low === 'object'){
					code += <>
						menuitem.FirebugAutocompleter_popup_menuitem %7B
							color: {pref} !important;
						%7D
					</>;
				}
				code += <>
					menuitem.FirebugAutocompleter_popup_menuitem[_type={str}] %7B
						color: {pref} !important;
					%7D
				</>;
			});
			code += <>
				#FirebugAutocompleter_popup,
				#FirebugAutocompleter_popup > vbox %7B 
					max-width : {Math.min(Math.max(50, PrefUtils.getPref('extensions.firebugautocompleter.popup.maxwidth')), window.screen.width)  + 'px !important;'};
					max-height: {Math.min(Math.max(100,PrefUtils.getPref('extensions.firebugautocompleter.popup.maxheight')),window.screen.height - 60) + 'px !important;'};
				%7D
				menuitem.FirebugAutocompleter_popup_menuitem[current='true'] %7B
					background-color: {PrefUtils.getPref('extensions.firebugautocompleter.backgroundcolor.current')} !important;
				%7D
				menuitem.FirebugAutocompleter_popup_menuitem[_moz-menuactive='true'] %7B
					background-color: -moz-menuhover !important;
					color: -moz-menuhovertext !important;
					opacity: 1 !important;
				%7D
				menuitem.FirebugAutocompleter_popup_menuitem[_moz-menuactive='true'][current='true'],
				menuitem.FirebugAutocompleter_popup_menuitem[current='true']:hover %7B
					background-color: {PrefUtils.getPref('extensions.firebugautocompleter.backgroundcolor.current.hover')} !important;
				%7D
			</>;
			return 'data:text/css,' + encodeURIComponent(unescape(code));	
		}
	};