<!--///////////////////////////////////////////////////////////////////////-->
<!--// (C) SCRT - Information Security, 2011 - Author Manoé Zwahlen      //-->
<!--///////////////////////////////////////////////////////////////////////-->
<!--// This program is free software: you can redistribute it and/or     //-->
<!--// modify it under the terms of the GNU General Public License as    //-->
<!--// published by the Free Software Foundation, either version 3 of    //-->
<!--// the License, or (at your option) any later version.               //-->
<!--// This program is distributed in the hope that it will be useful,   //-->
<!--// but WITHOUT ANY WARRANTY; without even the implied warranty of    //-->
<!--// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     //-->
<!--// GNU General Public License for more details.                      //-->
<!--// You should have received a copy of the GNU General Public License //-->
<!--// along with this program. If not, see http://www.gnu.org/licenses. //-->
<!--///////////////////////////////////////////////////////////////////////-->

///////////////////////////////////////////////////
// Function Name : createProgressBar
// Objective     : Création et affichage d'une fenêtre de progression
// Author        : Manoé Zwahlen
// Date          : 13.07.2011
// Parameter 1   : longueur minimum des mots de passe
// Parameter 2   : longueur maximum des mots de passe
// Parameter 3   : Nombre de caractère utilisé
// Parameter 4   : Nombre de mot de passe dans le dictionnaire (0 si utilisation de la génération)
///////////////////////////////////////////////////
function createProgressBar(lengthPasswordMin, lengthPassword, lengthChar, nbrPasswordDictionnary){
	
	//déclaration de l'objet DOM qui correspond à la fenêtre utilisée
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);	
	var win = wm.getMostRecentWindow("navigator:browser");
	var nbrPassword = 0;
	var nbrPasswordTmp = 0;
	
	if (nbrPasswordDictionnary >0){	
		nbrPassword = nbrPasswordDictionnary
		var progressBar = win.openDialog('chrome://fireforce/content/fireforce_progressBar.xul','FireforceProgressBar', '', nbrPassword, stopTest);
	}else{
		for (i=lengthPassword;i>=lengthPasswordMin;i--){
			nbrPasswordTmp = Math.pow(lengthChar, i);
			nbrPassword += nbrPasswordTmp;
		}
		var progressBar = win.openDialog('chrome://fireforce/content/fireforce_progressBar.xul','FireforceProgressBar', '', nbrPassword, stopTest);	
	}
	
	return progressBar;
}

///////////////////////////////////////////////////
// Function Name : createOptionDialogGeneration
// Objective     : Création et affichage d'une fenêtre de paramètre pour la génération de mot de passe
// Author        : Manoé Zwahlen
// Date          : 13.07.2011
// Parameter 1   : tableau pour stocker les paramètres
///////////////////////////////////////////////////
function createOptionDialogGeneration(inputValue){
	
	//déclaration de l'objet DOM qui correspond à la fenêtre utilisée
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);	
	var win = wm.getMostRecentWindow("navigator:browser");
	
	var params = {inn:null, out:null};
	var optionDialog = win.openDialog('chrome://fireforce/content/fireforce_optionDialogGeneration.xul','fireforce_optionDialogGeneration', 'modal', params);
	
					
	if (params.out) {
	  //l'utilisateur a cliqé sur ok
	  
	  inputValue[0] = params.out.min;
	  inputValue[1] = params.out.max;
	  inputValue[2] = params.out.textWrong;
	  inputValue[3] = params.out.prefLimit;
	  
	  return inputValue;
	}else {
	    //l'utilisateur a cliqé sur cancel
	}
}

///////////////////////////////////////////////////
// Function Name : createOptionDialogGeneration
// Objective     : Création et affichage d'une fenêtre de paramètre pour l'utilisation d'un dictionnaire
// Author        : Manoé Zwahlen
// Date          : 13.07.2011
// Parameter 1   : tableau pour stocker les paramètres
///////////////////////////////////////////////////
function createOptionDialogDictionnary(inputValue){
	
	//déclaration de l'objet DOM qui correspond à la fenêtre utilisée
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);	
	var win = wm.getMostRecentWindow("navigator:browser");
	
	var params = {inn:null, out:null};
	var optionDialog = win.openDialog('chrome://fireforce/content/fireforce_optionDialogDictionnary.xul','fireforce_optionDialogDictionnary', 'modal', params);
	
					
	if (params.out) {
	  //l'utilisateur a cliqé sur ok
	  
	  inputValue[0] = params.out.textWrong;
	  inputValue[1] = params.out.prefLimit;
	  
	  return inputValue;
	}else {
	    //l'utilisateur a cliqé sur cancel
	}
}