<!--///////////////////////////////////////////////////////////////////////-->
<!--// (C) SCRT - Information Security, 2011 - Author Manoé Zwahlen      //-->
<!--///////////////////////////////////////////////////////////////////////-->
<!--// This program is free software: you can redistribute it and/or     //-->
<!--// modify it under the terms of the GNU General Public License as    //-->
<!--// published by the Free Software Foundation, either version 3 of    //-->
<!--// the License, or (at your option) any later version.               //-->
<!--// This program is distributed in the hope that it will be useful,   //-->
<!--// but WITHOUT ANY WARRANTY; without even the implied warranty of    //-->
<!--// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     //-->
<!--// GNU General Public License for more details.                      //-->
<!--// You should have received a copy of the GNU General Public License //-->
<!--// along with this program. If not, see http://www.gnu.org/licenses. //-->
<!--///////////////////////////////////////////////////////////////////////-->

///////////////////////////////////////////////////
// Function Name : getGoodForm
// Objective     : Retourne les informations du formulaire sélectionné
// Author        : Manoé Zwahlen
// Date          : 05.01.2010
// Return        : Retourne le formulaire dans un objet
///////////////////////////////////////////////////
function getGoodForm(){

	//déclaration de l'objet DOM qui correspond à la fenêtre utilisée
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);	
	var win = wm.getMostRecentWindow("navigator:browser");
	
	//récupération du tagName de l'élément sélectionné
	var tagName = win.content.document.activeElement.tagName + " ";
	//récupération de l'élément sélectionne
	var activeElement = win.content.document.activeElement;
	var parentNodeTemp = activeElement;
	//si un élément a bien été sélectionné
	if (parentNodeTemp){
		
		//tant que le tagName de l'élément n'est pas "form", on va à l'élément parent
		while(!tagName.toLowerCase().match("form")){
			parentNodeTemp = parentNodeTemp.parentNode;
			tagName = parentNodeTemp.tagName + " ";
		}

		//retourne le formulaire dans un objet
		return parentNodeTemp;
	}else{
		alert("No form or selected field found!");	
	}
}

