<!--///////////////////////////////////////////////////////////////////////-->
<!--// (C) SCRT - Information Security, 2011 - Author Manoé Zwahlen      //-->
<!--///////////////////////////////////////////////////////////////////////-->
<!--// This program is free software: you can redistribute it and/or     //-->
<!--// modify it under the terms of the GNU General Public License as    //-->
<!--// published by the Free Software Foundation, either version 3 of    //-->
<!--// the License, or (at your option) any later version.               //-->
<!--// This program is distributed in the hope that it will be useful,   //-->
<!--// but WITHOUT ANY WARRANTY; without even the implied warranty of    //-->
<!--// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     //-->
<!--// GNU General Public License for more details.                      //-->
<!--// You should have received a copy of the GNU General Public License //-->
<!--// along with this program. If not, see http://www.gnu.org/licenses. //-->
<!--///////////////////////////////////////////////////////////////////////-->

///////////////////////////////////////////////////
// Function Name  : generatePassword
// Objective      : Générer toutes les valeurs possibles en fonction des choix de l'utilisateur
// Author         : Manoé Zwahlen
// Date           : 13.07.2011
// Parameter 1    : Type de caractère
// Parameter 2    : Longueur maximum
// Parameter 3    : Longueur minimum
// Parameter 4    : Texte qui identifie une mauvaise authentification
// Parameter 5    : Nombre de mot de passe par seconde
// Parameter 6    : Nom du champ sélectionné
// Parameter 7    : Fin de la requête
// Parameter 8    : Méthode de l'envoi
// Parameter 9    : Adresse du serveur
// Parameter 10   : objet contenant la fenêtre avec la barre de progression
///////////////////////////////////////////////////
function generatePassword(typeChar, lengthPassword, lengthPasswordMin, textWrong, prefLimit, selectedFieldName, finRequete, method, url, progressBar){
	
	//déclaration des variables 
	var dataTest = null;
	var nextValue = null;
	var nbrCharMax = lengthPassword;
	var nbrTotal = null;
	var firstChar = null;
	var lastPos = null;
	var nextPos = null;
	var char = null;
	
	passwordFound = 0;
	requestSent = 0;
	stopTest = 0;
	
	//déclaration de la variable char et attribution des bon caractère en fonction du choix de l'utilisateur
	switch (typeChar){
		case "a-z" :
			char = "abcdefghijklmnopqrstuvwxyz";	
			break;
		case "A-Z" :
			char = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";	
			break;
		case "0-9" :
			char = "0123456789";		
			break;
		case "a-zA-Z" :
			char = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";			
			break;
		case "a-z0-9" :
			char = "abcdefghijklmnopqrstuvwxyz0123456789";	
			break;
		case "A-Z0-9" :
			char = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
			break;
		case "a-zA-Z0-9" :
			char = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
			break;
		default :
			alert("Error this case is not possible");	
	}
	
	firstChar = char.charAt(0);

	for (compteurNbrPassword=2;compteurNbrPassword<=lengthPasswordMin;compteurNbrPassword++){
		firstChar += "" + char.charAt(0);
	}
	
	for (i=lengthPassword;i>=lengthPasswordMin;i--){
		nbrPasswordTmp = Math.pow(char.length, i);
		nbrTotal += nbrPasswordTmp;
	}
	
	nextValue = firstChar;
	for (compteurNbrPassword=1;compteurNbrPassword<=nbrTotal;compteurNbrPassword++){
		//vérifie qu'aucun mot de passe  n'a déjà été trouvé ou que le test n'a pas été arrêté
		if (passwordFound ==  0 && stopTest == 0){	
			dataTest = selectedFieldName+"="+nextValue+finRequete;
			if (compteurNbrPassword%prefLimit == 0){
				sendFormSynchronous(method, url, dataTest, textWrong, nbrTotal, progressBar, nextValue);
			} else {
				sendFormAsynchronous(method, url, dataTest, textWrong, nbrTotal, progressBar, nextValue);
			}
			nextValue = goToNextValue(char, nextValue);
		}
	}
}


///////////////////////////////////////////////////
// Function Name  : goToNextValue
// Objective      : générer le prochain mot de passe à tester en fonction du type de caractère et du dernier mot de passe testé
// Author         : Manoé Zwahlen
// Date           : 13.07.2011
// Parameter 1    : Type de caractère
// Parameter 2    : Dernier mot de passe testé
///////////////////////////////////////////////////
function goToNextValue(char, lastValue){
	var nbrChar = lastValue.length;
	var nextValue = "";
	var lastPos = parseInt(char.indexOf(lastValue, nbrChar-1));
	var compteurTab = nbrChar-1;
	var i=0;
	var tab = [];
	
	for (compteur=compteurTab;compteur>=0;compteur--){
		tab[i] = lastValue.charAt(compteur);
		i++;
	}
	
	for (compteur=0;compteur<nbrChar;compteur++){
		lastPos = parseInt(char.indexOf(tab[compteur], 0));
		if (lastPos < char.length-1){
			tab[compteur] = char.charAt(lastPos+1);
			break;
		}
	}
	
	if (compteur<nbrChar){
		for (u=0;u<compteur;u++){
			tab[u] = char.charAt(0);	
		}	
	} else {
		for (u=0;u<=nbrChar;u++){
			tab[u] = char.charAt(0);
		}	
	}
	
	for (u=tab.length-1;u>=0;u--){
		nextValue += tab[u] + "";
	}
	return nextValue;	
}
