<!--///////////////////////////////////////////////////////////////////////-->
<!--// (C) SCRT - Information Security, 2011 - Author Manoé Zwahlen      //-->
<!--///////////////////////////////////////////////////////////////////////-->
<!--// This program is free software: you can redistribute it and/or     //-->
<!--// modify it under the terms of the GNU General Public License as    //-->
<!--// published by the Free Software Foundation, either version 3 of    //-->
<!--// the License, or (at your option) any later version.               //-->
<!--// This program is distributed in the hope that it will be useful,   //-->
<!--// but WITHOUT ANY WARRANTY; without even the implied warranty of    //-->
<!--// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     //-->
<!--// GNU General Public License for more details.                      //-->
<!--// You should have received a copy of the GNU General Public License //-->
<!--// along with this program. If not, see http://www.gnu.org/licenses. //-->
<!--///////////////////////////////////////////////////////////////////////-->

///////////////////////////////////////////////////
// Function Name : selectFile
// Objective     : Ouvrir un explorateur de fichier pour choisis les dictionnaires 
// Author        : Manoé Zwahlen
// Date          : 06.01.2010
// Return        : Tableau avec les chemins des fichiers choisis
///////////////////////////////////////////////////
function selectFile() {
	const nsIFilePicker = Components.interfaces.nsIFilePicker;

	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	
	fp.init(window, "Choose a file", nsIFilePicker.modeOpenMultiple);
	fp.appendFilters(nsIFilePicker.filterAll | nsIFilePicker.filterText);

    //ouvre une explorateur de fichiers
	var rv = fp.show();
	//action si un ou des fichiers ont étés choisi
	if (rv == nsIFilePicker.returnOK || rv == nsIFilePicker.returnReplace) {
		var files = fp.files;
		//on stocke le chemin de chaque fichier dans le tableau paths
		var paths = [];
		while (files.hasMoreElements()){
			var arg = files.getNext().QueryInterface(Components.interfaces.nsILocalFile).path;
			paths.push(arg);
		}
		
		return paths;
	}
}

///////////////////////////////////////////////////
// Function Name : readFileLine
// Objective     : Récupérer les valeurs de chaque ligne du fichier
// Author        : Manoé Zwahlen
// Date          : 06.01.2010
// Parameter 1   : Chemin du fichier
// Parameter 2   : Tableau de mot de passe
// Return        : Tableau de mot de passe
///////////////////////////////////////////////////
function readFileLine(path, passwords) {
	var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	file.initWithPath(path);	
	
	//ouvrir un flux entrant depuis le fichier
	var istream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
	istream.init(file, 0x01, 0444, 0);
	istream.QueryInterface(Components.interfaces.nsILineInputStream);
 
	var line = {};
	var lines = []; 
	var hasmore = null;
	
	//stock la valeur de chaque ligne dans le tableau password
	do {
		hasmore = istream.readLine(line);
		lines.push(line.value);
		passwords.push(line.value);
	} while(hasmore);

    //fermeture du flux avec le fichier
	istream.close();
	
	return passwords;
}

///////////////////////////////////////////////////
// Function Name : makePasswordTab
// Objective     : Récupérer les valeurs de chaque ligne de tous les fichiers 
// Author        : Manoé Zwahlen
// Date          : 06.01.2010
// Return        : Tableau de mot de passe
///////////////////////////////////////////////////
function makePasswordsTab(){
	
	paths = selectFile();
	
	//vérifie qu'un fichier a bien été choisi
	if (paths){
		
		var passwords = [];
		//pour chaque fichiers choisis, on stocke les mots de passe dans le tableau passwords
		for (values in paths){readFileLine(paths[values], passwords);}
		  
		return passwords;
	} else {
		alert("No file selected!");
	}
}

