<!--///////////////////////////////////////////////////////////////////////-->
<!--// (C) SCRT - Information Security, 2011 - Author Manoé Zwahlen      //-->
<!--///////////////////////////////////////////////////////////////////////-->
<!--// This program is free software: you can redistribute it and/or     //-->
<!--// modify it under the terms of the GNU General Public License as    //-->
<!--// published by the Free Software Foundation, either version 3 of    //-->
<!--// the License, or (at your option) any later version.               //-->
<!--// This program is distributed in the hope that it will be useful,   //-->
<!--// but WITHOUT ANY WARRANTY; without even the implied warranty of    //-->
<!--// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     //-->
<!--// GNU General Public License for more details.                      //-->
<!--// You should have received a copy of the GNU General Public License //-->
<!--// along with this program. If not, see http://www.gnu.org/licenses. //-->
<!--///////////////////////////////////////////////////////////////////////-->

///////////////////////////////////////////////////
// Function Name  : sendFormAsynchronous
// Objective      : Envoie une requête asynchrone au serveur
// Author         : Manoé Zwahlen
// Date           : 13.07.2011
// Parameter 1    : Méthode de l'envoi
// Parameter 2    : Adresse du serveur
// Parameter 3    : Données à envoyer
// Parameter 4    : Texte qui identifie une mauvaise authentification
// Parameter 5    : Nombre total de mot passe à tester
// Parameter 6    : objet contenant la fenêtre avec la barre de progression
// Parameter 7    : mot de passe testé (utilisé pour affichage du résultat)	
///////////////////////////////////////////////////
function sendFormAsynchronous(method, url, data, textWrong, nbrTotal, progressBar, passwordTested){
	
	var xhr_object = null;
	var hashResponse = null;
	
	//vérifie qu'aucun mot de passe  n'a déjà été trouvé ou que le test n'a pas été arrêté
	if (passwordFound == 0 && stopTest == 0){
		//Création d'une instance de l'objet XMLHTTPRequest
		xhr_object = new XMLHttpRequest();	
	
		//Spécification la méthode de transmission des données, de l'URL et du mode de transmission de la requête
		xhr_object.open(method, url, true);
		
		//Création du header pour la requête
		xhr_object.setRequestHeader("Content-type", "application/x-www-form-urlencoded");		
		
		//envoi de la requête au serveur
		xhr_object.send(data);
		
		//Chaque fois que l'état de la requête change
		xhr_object.onreadystatechange = function() {
			//action si la requête en complétement envoyée	
			if(xhr_object.readyState == 4){
				//vérifie qu'aucun mot de passe  n'a déjà été trouvé ou que le test n'a pas été arrêté
				if (passwordFound == 0 && stopTest == 0){
					//récupération de la page retournée par le serveur
					testResponseText = xhr_object.responseText;
					//recherche dans la page si le texte apparait
					if(testResponseText.match(textWrong)){
						passwordFound += 0;
						requestSent += 1;
						//Mise à jour de la barre de progression
						progressBar.updateUI();
						
						if (requestSent == nbrTotal){
							//affichage du résultat du test
							progressBar.updateInformation("Password not found!");
						}
					//si le texte n'apparait pas, c'est que le mot de passe a été trouvé
					}else{
						passwordFound += 1;
						//affichage du résultat du test
						progressBar.updateInformation("Password found: " + passwordTested);
					}
				}
			}
		}
	}
}

///////////////////////////////////////////////////
// Function Name  : sendFormSynchronous
// Objective      : Envoie une requête synchrone au serveur
// Author         : Manoé Zwahlen
// Date           : 13.07.2011
// Parameter 1    : Méthode de l'envoi
// Parameter 2    : Adresse du serveur
// Parameter 3    : Données à envoyer
// Parameter 4    : Texte qui identifie une mauvaise authentification
// Parameter 5    : Nombre total de mot passe à tester
// Parameter 6    : objet contenant la fenêtre avec la barre de progression
// Parameter 7    : mot de passe testé (utilisé pour affichage du résultat)
///////////////////////////////////////////////////
function sendFormSynchronous(method, url, data, textWrong, nbrTotal, progressBar, passwordTested){
	var xhr_object = null;
	var hashResponse = null;
	
	//vérifie qu'aucun mot de passe  n'a déjà été trouvé ou que le test n'a pas été arrêté
	if (passwordFound == 0  && stopTest == 0){
		
		//Création d'une instance de l'objet XMLHTTPRequest
		xhr_object = new XMLHttpRequest();	
		
		//Spécification la méthode de transmission des données, de l'URL et du mode de transmission de la requête
		xhr_object.open(method, url, false);
		
		//Création du header pour la requête
		xhr_object.setRequestHeader("Content-type", "application/x-www-form-urlencoded");		
		
		//envoi de la requête au serveur
		xhr_object.send(data);
		
		//récupération de la page retournée par le serveur
		testResponseText = xhr_object.responseText;
		
		//vérifie qu'aucun mot de passe  n'a déjà été trouvé ou que le test n'a pas été arrêté
		if (passwordFound == 0 && stopTest == 0){			
			//recherche dans la page si le texte apparait
			if(testResponseText.match(textWrong)){
				requestSent += 1;
				passwordFound += 0;	
				//Mise à jour de la barre de progression
				progressBar.updateUI();
				
				if (requestSent == nbrTotal){
					//affichage du résultat du test
					progressBar.updateInformation("Password not found!");
				}
			//si le texte n'apparait pas, c'est que le mot de passe  a été trouvé
			}else{
				passwordFound += 1;
				//affichage du résultat du test
				progressBar.updateInformation("Password found : " + passwordTested);
			}
		}
	}
}
