/************************************************************************/
/*                                                                      */
/*      Tile Tabs  -  Firefox Extension  -  Open Layout Window          */
/*                                                                      */
/*      Javascript for Open Layout dialog                               */
/*                                                                      */
/*      Copyright (C) 2011  by  DW-dev                                  */
/*                                                                      */
/*      Last Edit  -  29 Oct 2011                                       */
/*                                                                      */
/************************************************************************/

var tileTabsOpenLayout =
{
    prefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.tiletabs."),
    
    onLoad: function()
    {
        var i,j,listbox,layoutString,layoutType,panelCount,row,cell;
        var children = new Array();
        
        listbox = document.getElementById("tiletabs-open-layoutlist");
        
        children = tileTabsOpenLayout.prefs.getChildList("layout-string-",{});
        children.sort();
        
        for (i = 0; i < children.length; i++)
        {
            layoutString = tileTabsOpenLayout.prefs.getCharPref(children[i]);
            
            j = layoutString.indexOf(";");
            layoutType = +layoutString.substr(0,j);
            layoutString = layoutString.substr(j+1);
            panelCount = +layoutString.substr(0,j);
            
            row = document.createElement("listitem");
            
            cell = document.createElement("listcell");
            cell.setAttribute("label",children[i].substr(14));
            cell.setAttribute("value",children[i].substr(14));
            row.appendChild(cell);
            
            cell = document.createElement("listcell");
            if (layoutType == 1) cell.setAttribute("label","\u25CF");
            cell.setAttribute("style","text-align: center;");
            row.appendChild(cell);
            
            cell = document.createElement("listcell");
            cell.setAttribute("label",panelCount);
            cell.setAttribute("style","text-align: center;");
            row.appendChild(cell);
            
            listbox.appendChild(row);
        }
    },
    
    onOkay: function()
    {
        var listbox;
        
        listbox = document.getElementById("tiletabs-open-layoutlist");
        
        if (listbox.itemCount == 0 || listbox.selectedIndex == -1) return false;
        
        window.arguments[0].layoutname = listbox.selectedItem.childNodes[0].getAttribute("value");
        
        return true;
    }
};
