/************************************************************************/
/*                                                                      */
/*      Tile Tabs  -  Firefox Extension  -  Options Window              */
/*                                                                      */
/*      Javascript for Options dialog                                   */
/*                                                                      */
/*      Copyright (C) 2010-2011  by  DW-dev                             */
/*                                                                      */
/*      Last Edit  -  29 Oct 2011                                       */
/*                                                                      */
/************************************************************************/

var tileTabsOptions =
{
    prefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.tiletabs."),
    
    appInfo: Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo),
    versionComparator: Components.classes["@mozilla.org/xpcom/version-comparator;1"].getService(Components.interfaces.nsIVersionComparator),
    ffVersion: "",
    
    initPrefs: function()
    {
        var i;
        var checkbox,checkstate;
        var menulist,index;
        var colorpicker,color;
        var keymods = new Array("Shift","Ctrl","Ctrl+Shift","Alt","Alt+Shift","Alt+Ctrl","Alt+Ctrl+Shift");
        var keyfnum = new Array("F1","F2","F3","F4","F5","F6","F7","F8","F9","F10","F11","F12");
        
        /* Determine Firefox version */
        
        if (tileTabsOptions.versionComparator.compare(tileTabsOptions.appInfo.version,"8.0b1") >= 0) tileTabsOptions.ffVersion = "8.0";
        else if (tileTabsOptions.versionComparator.compare(tileTabsOptions.appInfo.version,"4.0b1") >= 0) tileTabsOptions.ffVersion = "4.0";
        else tileTabsOptions.ffVersion = "3.6";
        
        /* Skin Options */
        
        colorpicker = document.getElementById("tiletabs-skin-color");
        try
        {
          color = tileTabsOptions.prefs.getCharPref("skin-color");
          colorpicker.color = color;
        }
        catch(e)
        {
          colorpicker.color = "#5070C0";
        }
        
        /* Tile Options */
        
        menulist = document.getElementById("tiletabs-tile-border");
        for (index = 0; index <= 4; index ++)
        {
          menulist.appendItem(index,index);
        }
        try
        {
          menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("tile-border");
        }
        catch(e)
        {
          menulist.selectedIndex = 2;
        }
        
        checkbox = document.getElementById("tiletabs-tile-syncactive");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("tile-syncactive");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        /* Splitter Options */
        
        menulist = document.getElementById("tiletabs-splitter-size");
        for (index = 2; index <= 10; index += 2)
        {
          menulist.appendItem(index,index);
        }
        try
        {
          menulist.selectedIndex = (tileTabsOptions.prefs.getIntPref("splitter-size")-2)/2;
        }
        catch(e)
        {
          menulist.selectedIndex = 2;
        }
        
        menulist = document.getElementById("tiletabs-splitter-snap");
        for (index = 10; index <= 30; index += 5)
        {
          menulist.appendItem(index,index);
        }
        try
        {
          menulist.selectedIndex = (tileTabsOptions.prefs.getIntPref("splitter-snap")-10)/5;
        }
        catch(e)
        {
          menulist.selectedIndex = 2;
        }
        
        /* Tab Options */
        
        checkbox = document.getElementById("tiletabs-tab-iconborder");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("tab-iconborder");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-tab-colortext");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("tab-colortext");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        checkbox = document.getElementById("tiletabs-tab-italictext");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("tab-italictext");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        checkbox = document.getElementById("tiletabs-tab-single");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("tab-single");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        checkbox = document.getElementById("tiletabs-tab-move");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("tab-move");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        checkbox = document.getElementById("tiletabs-tab-loadhome");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("tab-loadhome");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        checkbox = document.getElementById("tiletabs-tab-assignclose");
        try
        {
            checkstate = tileTabsOptions.prefs.getBoolPref("tab-assignclose");
            checkbox.checked = checkstate;
        }
        catch(e)
        {
            checkbox.checked = false;
        }
        
        checkbox = document.getElementById("tiletabs-tab-assignselect");
        try
        {
            checkstate = tileTabsOptions.prefs.getBoolPref("tab-assignselect");
            checkbox.checked = checkstate;
        }
        catch(e)
        {
            checkbox.checked = false;
        }
        
        checkbox = document.getElementById("tiletabs-tab-assignexist");
        try
        {
            checkstate = tileTabsOptions.prefs.getBoolPref("tab-assignexist");
            checkbox.checked = checkstate;
        }
        catch(e)
        {
            checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-tab-assignleft");
        try
        {
            checkstate = tileTabsOptions.prefs.getBoolPref("tab-assignleft");
            checkbox.checked = checkstate;
        }
        catch(e)
        {
            checkbox.checked = false;
        }
        
        checkbox = document.getElementById("tiletabs-tab-keepselect");
        try
        {
            checkstate = tileTabsOptions.prefs.getBoolPref("tab-keepselect");
            checkbox.checked = checkstate;
        }
        catch(e)
        {
            checkbox.checked = false;
        }
        
        /* Menu Options */
        
        checkbox = document.getElementById("tiletabs-menu-tilemenu");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("menu-tilemenu");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-menu-tilesubmenu");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("menu-tilesubmenu");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        checkbox = document.getElementById("tiletabs-menu-tile");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("menu-tile");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-menu-tilenew");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("menu-tilenew");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-menu-tiledup");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("menu-tiledup");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-menu-tilelink");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("menu-tilelink");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-menu-assign");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("menu-assign");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-menu-untile");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("menu-untile");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-menu-expand");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("menu-expand");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-menu-tabgroup");
        try
        {
          checkstate = tileTabsOptions.prefs.getBoolPref("menu-tabgroup");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
        
        /* Function Key Options */
        
        menulist = document.getElementById("tiletabs-fkey-new-mods");
        for (i = 0; i < 7; i++) menulist.appendItem(keymods[i],i+1);
        try
        {
            menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("fkey-new") >> 4;
        }
        catch(e)
        {
            menulist.selectedIndex = 0;
        }
        menulist = document.getElementById("tiletabs-fkey-new-fnum");
        for (i = 0; i < 12; i++) menulist.appendItem(keyfnum[i],i+1);
        try
        {
            menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("fkey-new") & 0x0F;
        }
        catch(e)
        {
            menulist.selectedIndex = 9;
        }
        
        menulist = document.getElementById("tiletabs-fkey-untile-mods");
        for (i = 0; i < 7; i++) menulist.appendItem(keymods[i],i+1);
        try
        {
            menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("fkey-untile") >> 4;
        }
        catch(e)
        {
            menulist.selectedIndex = 0;
        }
        menulist = document.getElementById("tiletabs-fkey-untile-fnum");
        for (i = 0; i < 12; i++) menulist.appendItem(keyfnum[i],i+1);
        try
        {
            menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("fkey-untile") & 0x0F;
        }
        catch(e)
        {
            menulist.selectedIndex = 2;
        }
        
        menulist = document.getElementById("tiletabs-fkey-expand-mods");
        for (i = 0; i < 7; i++) menulist.appendItem(keymods[i],i+1);
        try
        {
            menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("fkey-expand") >> 4;
        }
        catch(e)
        {
            menulist.selectedIndex = 0;
        }
        menulist = document.getElementById("tiletabs-fkey-expand-fnum");
        for (i = 0; i < 12; i++) menulist.appendItem(keyfnum[i],i+1);
        try
        {
            menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("fkey-expand") & 0x0F;
        }
        catch(e)
        {
            menulist.selectedIndex = 2;
        }
        
        menulist = document.getElementById("tiletabs-fkey-sync-mods");
        for (i = 0; i < 7; i++) menulist.appendItem(keymods[i],i+1);
        try
        {
            menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("fkey-sync") >> 4;
        }
        catch(e)
        {
            menulist.selectedIndex = 0;
        }
        menulist = document.getElementById("tiletabs-fkey-sync-fnum");
        for (i = 0; i < 12; i++) menulist.appendItem(keyfnum[i],i+1);
        try
        {
            menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("fkey-sync") & 0x0F;
        }
        catch(e)
        {
            menulist.selectedIndex = 8;
        }
        
        menulist = document.getElementById("tiletabs-fkey-view-mods");
        for (i = 0; i < 7; i++) menulist.appendItem(keymods[i],i+1);
        try
        {
            menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("fkey-view") >> 4;
        }
        catch(e)
        {
            menulist.selectedIndex = 0;
        }
        menulist = document.getElementById("tiletabs-fkey-view-fnum");
        for (i = 0; i < 12; i++) menulist.appendItem(keyfnum[i],i+1);
        try
        {
            menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("fkey-view") & 0x0F;
        }
        catch(e)
        {
            menulist.selectedIndex = 9;
        }
        
        tileTabsOptions.onFnumChange("new");
        tileTabsOptions.onFnumChange("untile");
        tileTabsOptions.onFnumChange("expand");
        tileTabsOptions.onFnumChange("sync");
        tileTabsOptions.onFnumChange("view");
        
        /* Mouse Options */
        
        menulist = document.getElementById("tiletabs-mouse-tile");
        for (i = 0; i < 7; i++) menulist.appendItem(keymods[i],i+1);
        try
        {
            menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("mouse-tile");
        }
        catch(e)
        {
            menulist.selectedIndex = 2;
        }
        
        menulist = document.getElementById("tiletabs-mouse-assign");
        for (i = 0; i < 7; i++) menulist.appendItem(keymods[i],i+1);
        try
        {
            menulist.selectedIndex = tileTabsOptions.prefs.getIntPref("mouse-assign");
        }
        catch(e)
        {
            menulist.selectedIndex = 2;
        }
        
        tileTabsOptions.onAssignSelectedChange();
        
        /* Startup Options */
        
        checkbox = document.getElementById("tiletabs-startup-restore");
        try
        {
            checkstate = tileTabsOptions.prefs.getBoolPref("startup-restore");
            checkbox.checked = checkstate;
        }
        catch(e)
        {
            checkbox.checked = true;
        }
        
        checkbox = document.getElementById("tiletabs-startup-default");
        try
        {
            checkstate = tileTabsOptions.prefs.getBoolPref("startup-default");
            checkbox.checked = checkstate;
        }
        catch(e)
        {
            checkbox.checked = false;
        }
    },
    
    savePrefs: function()
    {
        /* Skin Options */
        
        tileTabsOptions.prefs.setCharPref("skin-color",document.getElementById("tiletabs-skin-color").color);
        
        /* Tile Options */
        
        tileTabsOptions.prefs.setIntPref("tile-border",document.getElementById("tiletabs-tile-border").value);
        tileTabsOptions.prefs.setBoolPref("tile-syncactive",document.getElementById("tiletabs-tile-syncactive").checked);
        
        /* Splitter Options */
        
        tileTabsOptions.prefs.setIntPref("splitter-size",document.getElementById("tiletabs-splitter-size").value);
        tileTabsOptions.prefs.setIntPref("splitter-snap",document.getElementById("tiletabs-splitter-snap").value);
        
        /* Tab Options */
        
        tileTabsOptions.prefs.setBoolPref("tab-iconborder",document.getElementById("tiletabs-tab-iconborder").checked);
        tileTabsOptions.prefs.setBoolPref("tab-colortext",document.getElementById("tiletabs-tab-colortext").checked);
        tileTabsOptions.prefs.setBoolPref("tab-italictext",document.getElementById("tiletabs-tab-italictext").checked);
        tileTabsOptions.prefs.setBoolPref("tab-single",document.getElementById("tiletabs-tab-single").checked);
        tileTabsOptions.prefs.setBoolPref("tab-move",document.getElementById("tiletabs-tab-move").checked);
        tileTabsOptions.prefs.setBoolPref("tab-loadhome",document.getElementById("tiletabs-tab-loadhome").checked);
        tileTabsOptions.prefs.setBoolPref("tab-assignselect",document.getElementById("tiletabs-tab-assignselect").checked);
        tileTabsOptions.prefs.setBoolPref("tab-assignclose",document.getElementById("tiletabs-tab-assignclose").checked);
        tileTabsOptions.prefs.setBoolPref("tab-assignexist",document.getElementById("tiletabs-tab-assignexist").checked);
        tileTabsOptions.prefs.setBoolPref("tab-assignleft",document.getElementById("tiletabs-tab-assignleft").checked);
        tileTabsOptions.prefs.setBoolPref("tab-keepselect",document.getElementById("tiletabs-tab-keepselect").checked);
        
        /* Menu Options */
        
        tileTabsOptions.prefs.setBoolPref("menu-tilemenu",document.getElementById("tiletabs-menu-tilemenu").checked);
        tileTabsOptions.prefs.setBoolPref("menu-tilesubmenu",document.getElementById("tiletabs-menu-tilesubmenu").checked);
        tileTabsOptions.prefs.setBoolPref("menu-tile",document.getElementById("tiletabs-menu-tile").checked);
        tileTabsOptions.prefs.setBoolPref("menu-tilenew",document.getElementById("tiletabs-menu-tilenew").checked);
        tileTabsOptions.prefs.setBoolPref("menu-tiledup",document.getElementById("tiletabs-menu-tiledup").checked);
        tileTabsOptions.prefs.setBoolPref("menu-tilelink",document.getElementById("tiletabs-menu-tilelink").checked);
        tileTabsOptions.prefs.setBoolPref("menu-assign",document.getElementById("tiletabs-menu-assign").checked);
        tileTabsOptions.prefs.setBoolPref("menu-untile",document.getElementById("tiletabs-menu-untile").checked);
        tileTabsOptions.prefs.setBoolPref("menu-expand",document.getElementById("tiletabs-menu-expand").checked);
        tileTabsOptions.prefs.setBoolPref("menu-tabgroup",document.getElementById("tiletabs-menu-tabgroup").checked);
        
        /* Function Key Options */
        
        tileTabsOptions.prefs.setIntPref("fkey-new",document.getElementById("tiletabs-fkey-new-mods").value << 4 |
                                                    document.getElementById("tiletabs-fkey-new-fnum").value);
        tileTabsOptions.prefs.setIntPref("fkey-untile",document.getElementById("tiletabs-fkey-untile-mods").value << 4 |
                                                       document.getElementById("tiletabs-fkey-untile-fnum").value);
        tileTabsOptions.prefs.setIntPref("fkey-expand",document.getElementById("tiletabs-fkey-expand-mods").value << 4 |
                                                       document.getElementById("tiletabs-fkey-expand-fnum").value);
        tileTabsOptions.prefs.setIntPref("fkey-sync",document.getElementById("tiletabs-fkey-sync-mods").value << 4 |
                                                     document.getElementById("tiletabs-fkey-sync-fnum").value);
        tileTabsOptions.prefs.setIntPref("fkey-view",document.getElementById("tiletabs-fkey-view-mods").value << 4 |
                                                     document.getElementById("tiletabs-fkey-view-fnum").value);
        
        /* Mouse Options */
        
        tileTabsOptions.prefs.setIntPref("mouse-tile",document.getElementById("tiletabs-mouse-tile").value);
        tileTabsOptions.prefs.setIntPref("mouse-assign",document.getElementById("tiletabs-mouse-assign").value);
        
        /* Start-up Options */
        
        tileTabsOptions.prefs.setBoolPref("startup-restore",document.getElementById("tiletabs-startup-restore").checked);
        tileTabsOptions.prefs.setBoolPref("startup-default",document.getElementById("tiletabs-startup-default").checked);
    },
    
    onFnumChange: function(key)
    {
        if (document.getElementById("tiletabs-fkey-" + key + "-fnum").value == 0)
        {
            document.getElementById("tiletabs-fkey-" + key + "-mods").setAttribute("disabled","true");
            document.getElementById("tiletabs-fkey-" + key + "-mods").selectedIndex = 0;
        }
        else
        {
            document.getElementById("tiletabs-fkey-" + key + "-mods").removeAttribute("disabled");
        }
    },
    
    onAssignSelectedChange: function()
    {
        if (document.getElementById("tiletabs-tab-assignselect").checked)
        {
            document.getElementById("tiletabs-mouse-assign").setAttribute("disabled","true");
            document.getElementById("tiletabs-mouse-warning").setAttribute("hidden","false");
        }
        else
        {
            document.getElementById("tiletabs-mouse-assign").removeAttribute("disabled");
            document.getElementById("tiletabs-mouse-warning").setAttribute("hidden","true");
        }
    }
};
