/************************************************************************/
/*                                                                      */
/*      Tile Tabs  -  Firefox Extension  -  Save Layout Window          */
/*                                                                      */
/*      Javascript for Save Layout dialog                               */
/*                                                                      */
/*      Copyright (C) 2011  by  DW-dev                                  */
/*                                                                      */
/*      Last Edit  -  21 Nov 2011                                       */
/*                                                                      */
/************************************************************************/

var tileTabsSaveLayout =
{
    prefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.tiletabs."),
    
    onLoad: function()
    {
        var i,j,listbox,layoutString,layoutType,panelCount,row,cell;
        var children = new Array();
        
        listbox = document.getElementById("tiletabs-save-layoutlist");
        
        children = tileTabsSaveLayout.prefs.getChildList("layout-string-",{});
        children.sort();
        
        for (i = 0; i < children.length; i++)
        {
            layoutString = tileTabsSaveLayout.prefs.getCharPref(children[i]);
            
            j = layoutString.indexOf(";");
            layoutType = +layoutString.substr(0,j);
            layoutString = layoutString.substr(j+1);
            panelCount = +layoutString.substr(0,j);
            
            row = document.createElement("listitem");
            
            cell = document.createElement("listcell");
            cell.setAttribute("label",children[i].substr(14));
            cell.setAttribute("value",children[i].substr(14));
            row.appendChild(cell);
            
            cell = document.createElement("listcell");
            if (layoutType == 1) cell.setAttribute("label","\u25CF");
            cell.setAttribute("style","text-align: center;");
            row.appendChild(cell);
            
            cell = document.createElement("listcell");
            cell.setAttribute("label",panelCount);
            cell.setAttribute("style","text-align: center;");
            row.appendChild(cell);
            
            listbox.appendChild(row);
        }
        
        document.getElementById("tiletabs-save-layoutname").value = window.arguments[0].layoutname;
        document.getElementById("tiletabs-save-layouttabs").checked = window.arguments[0].layouttabs;
        
        document.getElementById("tiletabs-save-layoutname").focus();
    },
    
    onOkay: function()
    {
        if (document.getElementById("tiletabs-save-layoutname").value.length == 0) return false;
        
        if (document.getElementById("tiletabs-save-layoutname").value.match(/^[a-zA-Z0-9_]+$/) == null)
        {
            alert(document.getElementById("tiletabs-save-invalidname").value);
            return false;
        }
        
        window.arguments[0].layoutname = document.getElementById("tiletabs-save-layoutname").value;
        window.arguments[0].layouttabs = document.getElementById("tiletabs-save-layouttabs").checked;
        
        return true;
    },
    
    onSelect: function()
    {
        var listbox;
        
        listbox = document.getElementById("tiletabs-save-layoutlist");
        
        document.getElementById("tiletabs-save-layoutname").value = listbox.selectedItem.childNodes[0].getAttribute("value");
    }
};
