/* *********************************************************************************

Copyright (C) 2005-2011  Jennifer Madden
View Source Chart is a Source Charting DOM Inspector

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

JenniferMadden.com
jennifer@jennifermadden.com 

*********************************************************************************** */
/*
View Source Chart
Inspect the DOM at lightning speed. If you're new to the containment concept, one glance at a Source Chart and you're over the learning curve.
3/2010 Jamie Butterfield (Angel) Updated View Source Chart to comply with AMO namespace standard.
9/2008 Jamie Butterfield Update to work on Fx3: fixed view in popup window mode, box-collapse-into-viewport working. 
9/24/2006 Jennifer Madden
Version 2.5 displays javascripts as part of a page chart. Cool!

9/18/2006 Jennifer Madden
V2.4.04 Moved all style declarations into separate javascript file, "style.js", which in turn writes decs to the source chart window. This allows for easy script access, as well as easy css editing with Web Developer Extension. 

06/03/2006 Jennifer Madden
Version 2.4 attempts to allow copying of text without the collapsing of containers. If text is selected, a container will not collapse. Containers can, however, be expanded if text is selected. This version makes further improvements to whitespace handling, and creates a seperate style sheet for easy modification of default styles.
*/
//
//  Tue Jul 12 21:01:16 2005 -- Scott R. Turner
//  Modifications to make VRS compatible with Platypus.
//  getComments
//  Tue Jul 12 21:01:36 2005 -- Scott R. Turner
//  Added comments
//  Extracts all the comment nodes into an array.

// Here is the stringbundle definition to localize one string of the .js file
// goofy Feb 8th 2007
if(!com) var com = {};
if(!com.jmadden) com.jmadden = {};
if(!com.jmadden.vrsOverlay) com.jmadden.vrsOverlay = {};


com.jmadden.vrsOverlay = {
  vrspagetitle: "",
  vrsmotto: "",
  gVRSwin: false,
  vsc_scripts: false,
  scrTags: false,
  vscEndPoint: "",
  defineStrings: function(){
	var gvrsBundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
	var mystrings = gvrsBundle.createBundle("chrome://vrs/locale/vrs.properties");
	com.jmadden.vrsOverlay.vrspagetitle = mystrings.GetStringFromName("PageTitle");
	com.jmadden.vrsOverlay.vrsmotto = mystrings.GetStringFromName("MaddenMotto");
  },
  getComments: function (pnode) {
	return com.jmadden.vrsOverlay.doGetComments(pnode, new Array());
  },
  doGetComments: function (node, c) {
	if (node.nodeType == 8) {
	   c.push(node.nodeValue);
	} else if (node.childNodes != null) {
	  for (var i=0; i < node.childNodes.length; ++i ) {
		com.jmadden.vrsOverlay.doGetComments(node.childNodes.item(i), c );
	  }
	}
	return c;
  },
  /*  
  Puts space after "<" and space before ">" to create flag 
  which will keep commented html from being styled
  */
  alteredComment: function (comment) {
	  comment = comment.replace(/</g,"< ").replace(/>/g," >");
	  return comment;
  },
  getScripts: function (scriptTagArray, scriptsHolder) {
	com.jmadden.vrsOverlay.scrTags = scriptTagArray;
	for(var si=0; si<com.jmadden.vrsOverlay.scrTags.length; si++) {
		  if (com.jmadden.vrsOverlay.scrTags[si].childNodes[0]) {
if(com.jmadden.vrsOverlay.scrTags[si].childNodes.length > 1){
var thisisthelength = com.jmadden.vrsOverlay.scrTags[si].childNodes.length;
for(var xx=1; xx<thisisthelength; xx++){
com.jmadden.vrsOverlay.scrTags[si].childNodes[xx].nodeValue="";
}
}
scriptsHolder.push(com.jmadden.vrsOverlay.scrTags[si].childNodes[0].nodeValue);
			com.jmadden.vrsOverlay.scrTags[si].childNodes[0].nodeValue="scriptHolderArray"+si; //changing contents of script tags.
		  } else {
			scriptsHolder.push("");
		  }
	}	
	return scriptsHolder;
  },
  /*  isFrameset()
	  Tue Jul 12 21:03:47 2005 -- Scott R. Turner
	  Added comments
      Called from the tools menu; uses window.content to identify the
      source to display.
 */
  isFrameset: function () {
	var vrs_getFrame = window.content;	
	
	//the following line replaces above "script markers" functionality with actual javascripts!!
	com.jmadden.vrsOverlay.vsc_scripts = com.jmadden.vrsOverlay.getScripts(vrs_getFrame.document.getElementsByTagName("script"), new Array());
	
	var pageContents = vrs_getFrame.document.getElementsByTagName("html")[0].innerHTML;
	var ca = com.jmadden.vrsOverlay.getComments(vrs_getFrame.document.getElementsByTagName("html")[0]);
	
	for (var a=0; a<ca.length; a++) {
		pageContents=pageContents.replace("<!--"+ca[a]+"-->","<!--"+com.jmadden.vrsOverlay.alteredComment(ca[a])+"-->");
	};
	
	var rendered = pageContents;
	com.jmadden.vrsOverlay.handleSource(rendered);
  },  
  /*
  The following  function prepares source to be styled; 
  handles JavaScript code found between script tags,
  finds head and body comments and flags all tags 
  within them so they are not treated like regular tags,
  divides source into two groups - head and body, 
  then escapes them in order to remove extra returns,
  rebuilds the body tag and re-inserts it back into 
  place before sending altered source to styling function.
 */
  prepareSource: function () {
    var vrs_getWin = document.commandDispatcher.focusedWindow;
	
	//the following line replaces above "script markers" functionality with actual javascripts!!
	com.jmadden.vrsOverlay.vsc_scripts = com.jmadden.vrsOverlay.getScripts(vrs_getWin.document.getElementsByTagName("script"), new Array());

	var vsc_styleTag = vrs_getWin.document.getElementsByTagName("style");//TO DO: insert breaks

    var headContents = vrs_getWin.document.getElementsByTagName("head")[0].innerHTML;
    var bodyContents = vrs_getWin.document.getElementsByTagName("body")[0].innerHTML;
    var bodyTag = vrs_getWin.document.getElementsByTagName("body")[0];
    var attslist = "";

    var bc = com.jmadden.vrsOverlay.getComments(vrs_getWin.document.getElementsByTagName("body")[0]); 
	//flag html in body's comments
    for(var b = 0; b < bc.length; b++){
	  bodyContents = bodyContents.replace("<!--"+bc[b]+"-->","<!--"+com.jmadden.vrsOverlay.alteredComment(bc[b])+"-->");
    }
    var hc = com.jmadden.vrsOverlay.getComments(vrs_getWin.document.getElementsByTagName("head")[0]); 
	
	//flag html in head's comments
    for(var a=0; a<hc.length; a++){
	  headContents=headContents.replace("<!--"+hc[a]+"-->","<!--"+com.jmadden.vrsOverlay.alteredComment(hc[a])+"-->");
    };

    for(i=0; i < bodyTag.childNodes[0].parentNode.attributes.length; i++){ 
	  //rebuild body tag with all its attributes
	  atts = bodyTag.childNodes[0].parentNode.attributes[i];
	  attslist += " " + atts.nodeName + "=\"" + atts.nodeValue + "\"";
    };
	
	headContents=headContents.replace(/\r+|\n+/g,'');
	bodyContents=bodyContents.replace(/\r+|\n+/g,'');
    
    var rendered = "<head>" + headContents + "</head>\n<body"+
		attslist + ">" + bodyContents + "\n</body>";
	
    com.jmadden.vrsOverlay.handleSource(rendered);
  },
  /*  handleSource
	  Tue Jul 12 21:05:03 2005 -- Scott R. Turner
      placed code to find and code to replace with in multi-dimensional array
      and split/join methods moved inside a loop which iterates through array.
	  the handleSource function takes the html string and adds 
	  text styling, color-coding and formatting using split and join 
	  methods to find tags and replace them with renderable, styled tags
  */
  handleSource: function (rendered) {
	var vscContainer_TitleCursor = ' onmouseover="this.title=this.childNodes[0] && this.childNodes[0].nodeType!=1 ? this.childNodes[0].nodeValue : this.title;this.style.cursor=\'pointer\';"';
	var vscTag_TitleCursor = ' onmouseover="this.style.cursor=\'auto\';this.title=\' \';"';
	
    var rendered_table =
	[
	  ["<","\n<"],
	  [">",">\n"],
	  ["&","&amp;"],
	  ["<","&lt;"],
	  [">","&gt;"]
	];
    for (var i=0;i < rendered_table.length;i++) {
	  rendered = rendered.split(rendered_table[i][0]);
	  rendered = rendered.join(rendered_table[i][1]);
    };

	rendered=rendered.replace(/(&lt;(?! ?\/)(?=head(?= |&)|title|body|script|style|article|section|header|aside|footer|nav|dialog|figure|figcaption|canvas|svg|div|span|p(?= |&)|table|thead|tfoot|tr|th|td|frameset|iframe|ul|ol|dl|dt|dd|li(?= |&)|blockquote))(\w+)/gi,'<div id="$2Tag"'+vscContainer_TitleCursor+'>$1$2');
	rendered=rendered.replace(/(&lt;(?! ?\/)(?=a(?= |&)|form|select|option|legend|fieldset|textarea|h[1-6]|center|caption|code|em(?= |&)|i(?= |&)|strong|b(?= |&)|font|m(?= |&)|progress|time|meter))(\w+)/gi,'<div id="$2Tag"'+vscTag_TitleCursor+'>$1$2');
	rendered=rendered.replace(/(&lt; ?\/(head|title|body|script|style|article|section|header|aside|footer|nav|dialog|figure|figcaption|canvas|svg|div|span|table|thead|tfoot|tr|th|td|frameset|iframe|ul|ol|dl|dt|dd|li|p|blockquote|code|a|form|select|option|legend|fieldset|textarea|em|i|strong|b|font|h[1-6]|center|caption|time|progress|m|meter)&gt;)/gi,'$1</div>');
	rendered=rendered.replace(/&lt;!--/gi,'<div id="commTag"'+vscContainer_TitleCursor+'>&lt;!--');
	rendered=rendered.replace(/--&gt;/gi,'--&gt;</div>');

	/*removes whitespace using regexps. */
	rendered=rendered.replace(/\n\s*\n/gm,'\n');
	rendered=rendered.replace(/\n<blockquote/gm,'<blockquote');
	rendered=rendered.replace(/<\/blockquote>\n/gm,'</blockquote>');
	rendered=rendered.replace(/\n<div/gm,'<div');
	rendered=rendered.replace(/<\/div>\n/gm,'</div>');
	
	//replacing the "<" in array-stored javascripts with "&lt;"
	for(var sc=0; sc < com.jmadden.vrsOverlay.vsc_scripts.length; sc++){
	  if(com.jmadden.vrsOverlay.vsc_scripts[sc]!=""){
		com.jmadden.vrsOverlay.vsc_scripts[sc] = com.jmadden.vrsOverlay.vsc_scripts[sc].replace(/</gm,"&lt;");
	  } else {
		continue;
	  }
	}
	
	for(var sc2=0; sc2<com.jmadden.vrsOverlay.vsc_scripts.length; sc2++){
	  if(com.jmadden.vrsOverlay.vsc_scripts[sc2]!=""){
		//put array-stored scripts back into rendered string to display in chart
		rendered = rendered.replace('scriptHolderArray'+sc2,com.jmadden.vrsOverlay.vsc_scripts[sc2]);	
		
		//put scripts back into page source in case vsc is executed again w/out refreshing
		//com.jmadden.vrsOverlay.scrTags[sc2].childNodes[0].nodeValue = com.jmadden.vrsOverlay.scrTags[sc2].childNodes[0].nodeValue.replace('scriptHolderArray'+sc2,com.jmadden.vrsOverlay.vsc_scripts[sc2]);
	  } else {
		continue;
	  }
	}
	

	var vrs_doctypeTag = "";
	var vrs_htmlTag = "";
	for(var len=0; len < window.content.document.childNodes.length; len++){
	  //root document will have at least 1 childNode (HTML tag), or 2 childNodes (doctype & HTML tag)
	  var rootDocChild = window.content.document.childNodes[len];
	  if(rootDocChild.nodeType==1){		//is first root doc childNode an element? 
		//if so, then it must be an HTML tag (static or dynamically added by Fx) 
		if(rootDocChild.attributes.length>0){//if this html tag has at least one attribute
			var vrs_htmlAtts = "";
			var vrs_htmlAttsLen = rootDocChild.attributes.length;
				for(var a=0; a<vrs_htmlAttsLen; a++){//get all attribute names/values
				vrs_htmlAtts += " " + rootDocChild.attributes[a].nodeName + "=\"" + rootDocChild.attributes[a].nodeValue + "\"";
				}
			vrs_htmlTag += "&lt;"+rootDocChild.nodeName + "<span style=\"color:#669966;\">" + vrs_htmlAtts + "</span>&gt;";
		}else{//the html tag has no attributes
			vrs_htmlTag += "&lt;"+rootDocChild.nodeName+"&gt;";
		}
	  }else{
		if(rootDocChild.nodeType==10){//it's not an HTML tag, so it must be the doctype dtd	
		  var doc_type = window.content.document.doctype;
		  vrs_doctypeTag += "<span style=\"color:#37A8E9;font-style: italic;\">&lt;!DOCTYPE "+doc_type.name;
		  vrs_doctypeTag += (doc_type.publicId) ? " PUBLIC \""+doc_type.publicId+"\"" : "";						
		  vrs_doctypeTag += (doc_type.systemId) ? "<br>\""+ doc_type.systemId+"\"&gt;" : "&gt;";
		  vrs_doctypeTag += "</span><BR>";
		}
	  }  //end else
	}//end for
  
	//using escape preserved formatting but destroyed display of non-english characters
	rendered = rendered.replace(/\n/gm,"<br>");
	rendered = rendered.replace(/<br><br>/gm,"<br>");//scripts' whitespace isn't handled, so handle it here
	var VSC_Source="";
	
	VSC_Source += "<script type=\"application/x-javascript\" src=\"chrome://vrs/content/collapse.js\"></script>\n";
	
			var pref = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefService).
			getBranch("extensions.vrs.");//components classes code obsolete
			if(pref.getPrefType("sourcewin") == pref.PREF_BOOL && pref.getBoolPref("sourcewin") == true) {		//open in a tab	
			  VSC_Source += com.jmadden.style2 + "";
			} else {
			VSC_Source += com.jmadden.style + "";
			}
	
	//VSC_Source += com.jmadden.style + "";
	
	VSC_Source += "<span style=\"white-space: -moz-pre-wrap;font-family:verdana;font-size:10px;\">";
	VSC_Source += vrs_doctypeTag + vrs_htmlTag + rendered+"&lt;/html&gt;";
	VSC_Source += "</span>";
	VSC_Source += "<!-- "+com.jmadden.vrsOverlay.vrsmotto+" -->";
  
	//
	//  Tue Jul 12 21:05:03 2005 -- Scott R. Turner
	//  Added preferences checkbox with option to view source in new window
	//  Check to see if the user wants to open in a window or
	//  a tab.
	//

	contentTitle=window.content.document.title;
	
	//open in a tab	
	  gBrowser.selectedTab=gBrowser.addTab();
	  var newvrsTab=gBrowser.getBrowserForTab(gBrowser.selectedTab);
	  newvrsTab.addEventListener("load", function() { newvrsTab.contentDocument.body.innerHTML = VSC_Source;newvrsTab.contentDocument.title="Source Chart for "+ contentTitle;}, true);  //getElementsByTagName("html")[0]

  }
};

com.jmadden.vrsOverlay.defineStrings();